/*

	DISASSEMBLER

*/

#include <string.h>
#include <dos.h>
#include <mem.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#define maxBkp 40

extern int Assembler( const char s[], unsigned PC );

extern unsigned int NextPC;
extern unsigned char StrInstr[50];
extern far unsigned char *PRAM;
extern unsigned RAM;
extern far unsigned char *PROM;
extern unsigned ROM;
extern unsigned char _ASCII;
extern char emulDirectory[78];
extern unsigned FindBytes();
extern unsigned NextBytes();
extern char * ZXSharpVRAM( unsigned );
extern unsigned DecodeAdress();
extern void showSInfo();
extern SpectrumLoad();
extern DosLoad();
extern ErrPrm();
extern SetMemory();
extern Calc();
extern RamDisk();

extern "C" {
int ASCIIS(int);
int ASCIISX(int);
unsigned int far getsize(int PC);
void far defshow(int PC);
void far getdword(int PC);
void far getdbyte(int PC);
void far getinstr(int PC);
void far InvRadek(int);
void far InvRadekB(int);
void far * far getSPointer();
void far * far getPtrMSTS();

void allInit( unsigned, unsigned, unsigned );
unsigned trap();
unsigned trace();
unsigned emu_run();
unsigned gotoCursor();
void switchRAM();
void showScreen();
void showScrZX();
}

extern void saveMemory();
extern void loadMemory();

int SMode = 1;	// show mode (1=CPU; 2=DUMP BYTE; 3=DUMP WORD)
unsigned int ACPU = 0;
unsigned int CPUofs = 0;
unsigned int DBYTE = 0;
unsigned int DWORD = 0;
char CL[80];		// Command Line
int Cur;		// Cursor
int _Assembler = 0;
int printReg = 0;
extern int lineWidth;
unsigned Breakpoints[maxBkp];		// adresy breakpointu
int      BkpUsed[maxBkp];		// pouzite breakpointy
char	 BkpMap[maxBkp];		// kde vubec je ...
char	 BkpOld[maxBkp];		// stare byty
int RDHandle;
unsigned pending;

#define kbUp 		0x4800
#define kbDown          0x5000
#define kbLeft		0x4b00
#define kbRight		0x4d00
#define kbPgUp		0x4900
#define kbPgDn		0x5100
#define kbHome		0x4700
#define kbEnd		0x4f00
#define kbDel		0x5300
#define kbF1		0x3b00
#define kbF2		0x3c00
#define	kbF3		0x3d00
#define kbF4		0x3e00
#define kbF5		0x3f00
#define kbF6		0x4000
#define kbF7		0x4100
#define kbF8		0x4200
#define kbF9		0x4300
#define kbF10		0x4400
#define kbAltF3		0x6a00

struct TRegisters {
unsigned AF;
unsigned BC;
unsigned DE;
unsigned HL;
unsigned IX;
unsigned IY;
unsigned AF1;
unsigned BC1;
unsigned DE1;
unsigned HL1;
unsigned SP;
unsigned PC;
unsigned I;
unsigned R;
} OldRegisters;

struct TSTSMEM {
unsigned char MEMSTS;
char nic1;
unsigned char MODE;
char nic2;
unsigned char VMODE;
char nic3;
};

TRegisters far *PReg;
TSTSMEM far *PSTSMEM;

void Beep()
{
  sound(440); delay(50); sound(880); delay(50); sound(440); delay(50);
  nosound();
}

void enableCursor()
{
  _AH = 1; _CX = 0x0607; asm int 10h;
}

void disableCursor()
{
  _AH = 1; _CX = 0x0f00; asm int 10h;
}

void SetBkpNormal( int i )
{
  BkpOld[ i ] = PRAM[ Breakpoints[ i ] ];
  PRAM[ Breakpoints[i] ] = 0x6d;		// kod breakpointu    LD L, L
}

void SetBkpROM( int i, unsigned adr )
{
  BkpOld[i] = PROM[ adr ];
  PROM[ adr ] = 0x6d;
}

void breakpointsSet()
{
  int i;
  for (i = 0; i < maxBkp; i++)
    if ( BkpUsed[i] )
      {
	if ( Breakpoints[i] < 0x1000 )
	  {
	    if ( (BkpMap[i] & 1) != 0 )		// v ROMCE ?
	      {
		if ( (PSTSMEM -> MEMSTS & 1) != 0 )   // je tam ?
		  SetBkpNormal( i );
		 else
		  SetBkpROM( i, Breakpoints[i] );
	      }
	     else
	      {
		if ( (PSTSMEM -> MEMSTS & 1) != 0 )   // romka ?
		  SetBkpROM( i, Breakpoints[i] );
		 else
		  SetBkpNormal( i );
	      }
	    continue;				// pokracuj
	  }
	if ( Breakpoints[i] >= 0xe000 )
	  {
	    if ( (BkpMap[i] & 8) != 0 )		// v ROMCE ?
	      {
		if ( (PSTSMEM -> MEMSTS & 8) != 0 )   // je tam ?
		  SetBkpNormal( i );
		 else
		  SetBkpROM( i, Breakpoints[i] - 0xc000 );
	      }
	     else
	      {
		if ( (PSTSMEM -> MEMSTS & 8) != 0 )   // romka ?
		  SetBkpROM( i, Breakpoints[i] - 0xc000 );
		 else
		  SetBkpNormal( i );
	      }
	    continue;				// pokracuj
	  }
	SetBkpNormal( i );
      }
}

void ResBkpNormal( int i )
{
  PRAM[ Breakpoints[ i ] ] = BkpOld[ i ];
}

void ResBkpROM( int i, unsigned adr )
{
  PROM[ adr ] = BkpOld[ i ];
}

void breakpointsRes()
{
  int i;
  for (i = 0; i < maxBkp; i++)
    if ( BkpUsed[i] )
      {
	if ( Breakpoints[i] < 0x1000 )
	  {
	    if ( (BkpMap[i] & 1) != 0 )		// v ROMCE ?
	      {
		if ( (PSTSMEM -> MEMSTS & 1) != 0 )   // je tam ?
		  ResBkpNormal( i );
		 else
		  ResBkpROM( i, Breakpoints[i] );
	      }
	     else
	      {
		if ( (PSTSMEM -> MEMSTS & 1) != 0 )   // romka ?
		  ResBkpROM( i, Breakpoints[i] );
		 else
		  ResBkpNormal( i );
	      }
	    continue;				// pokracuj
	  }
	if ( Breakpoints[i] >= 0xe000 )
	  {
	    if ( (BkpMap[i] & 8) != 0 )		// v ROMCE ?
	      {
		if ( (PSTSMEM -> MEMSTS & 8) != 0 )   // je tam ?
		  ResBkpNormal( i );
		 else
		  ResBkpROM( i, Breakpoints[i] - 0xc000 );
	      }
	     else
	      {
		if ( (PSTSMEM -> MEMSTS & 8) != 0 )   // romka ?
		  ResBkpROM( i, Breakpoints[i] - 0xc000 );
		 else
		  ResBkpNormal( i );
	      }
	    continue;				// pokracuj
	  }
	ResBkpNormal( i );
      }
}

unsigned int PrevPC(int Count)
{
  unsigned int PC;

  switch (SMode) {
    case 1:
      {
	PC = ACPU;
	while (Count > 0)
	  {
	    if (getsize(PC - 4) != PC)
	      {
		if (getsize(PC - 3) != PC)
		  {
		    if (getsize(PC - 2) != PC)
		      PC--;
		     else
		    PC -= 2;
		  }
		 else
		  PC -= 3;
	      }
	     else
	      PC -= 4;
	    Count--;
	  }
	break;
      }
    case 2:
      {
	PC = DBYTE - (Count * 8);
	break;
      }
    case 3:
      {
	PC = DWORD - (Count * 8);
	break;
      }
  }
  return PC;
}

unsigned int _NextPC(int Count)
{
  unsigned int PC;

  switch (SMode) {
    case 1:
      {
	PC = ACPU;
	while (Count > 0)
	  {
	    PC = getsize(PC);
	    Count--;
	  }
	break;
      }
    case 2:
      {
	PC = DBYTE + Count * 8;
	break;
      }
    case 3:
      {
	PC = DWORD + Count * 8;
	break;
      }
  }
  return PC;
}

unsigned PrevPC1(int Count)
{
  unsigned PC = ACPU;
  ACPU = CPUofs;
  unsigned Result = PrevPC(Count);
  ACPU = PC;
  return Result;
}

unsigned _NextPC1(int Count)
{
  unsigned PC = ACPU;
  ACPU = CPUofs;
  unsigned Result = _NextPC(Count);
  ACPU = PC;
  return Result;
}

void AdrWrite(unsigned int Adr)
{
  unsigned int PC1;
  switch (SMode) {
    case 1: {
       if ( ACPU > Adr ) { ACPU = CPUofs = Adr; return; }
       PC1 = _NextPC( 24 );
       if ( Adr > PC1 ) { ACPU = CPUofs = Adr; return; }
       CPUofs = Adr;
       if ( Adr == PC1 ) ACPU = _NextPC( 1 );
       break;
    }
    case 2: { DBYTE = Adr; break; }
    case 3: { DWORD = Adr; break; }
  }
}

void AdrWriteX(unsigned Adr)
{
  if (SMode != 1) AdrWrite(Adr);
    else
      ACPU = CPUofs = Adr;
}

void putRegs( int y, int word, const char s[], unsigned akt, unsigned old )
{
  if ( y >= 0x100 )
    {
      gotoxy( 70, y & 0xff );
      cputs( " " );
    }
   else
    {
      gotoxy( 59, y );
      cputs( " " );
    }
  cputs( s );
 if ( akt != old ) textattr(0x70);
    else textattr(0x1e);
  if ( word ) cprintf( "%04X", akt );
    else cprintf( "%02X", akt );
  textattr(0x1e); putch(' ');
}

void putFlag( int x1, int x2 )
{
  if (x1 != x2) textattr(0x70); else textattr(0x1e);
  if (x1 != 0) putch('1'); else putch('0');
  textattr(0x1e); cputs("  ");
}

void ShowCPU()
{
  int i;
  unsigned int PC;

  disableCursor();
  lineWidth = 58;
  PC = ACPU;
  for (i = 1; i <= 24; i++)
    {
       getinstr(PC);
       if (PC == PReg -> PC) *(int*)&StrInstr[4] = '';
       cputs(StrInstr);
       cputs("    \x0d\x0a");
       if (PC == CPUofs) InvRadek(i);
       int ppp = 0;
       while ( ppp < maxBkp )
	 {
	   if ( BkpUsed[ppp] && (PC == Breakpoints[ppp]) ) break;
	   ppp++;
	 }
       if (ppp < maxBkp) InvRadekB(i);
       PC = NextPC;
    }
  if ( printReg )
    {
      enableCursor();
      return;
    }
  printReg = 1;
  putRegs(1, 0, " A    ", (PReg -> AF) & 0xff, OldRegisters. AF & 0xff);
  putRegs(2, 1, "BC  ", PReg -> BC, OldRegisters. BC);
  putRegs(3, 1, "DE  ", PReg -> DE, OldRegisters. DE);
  putRegs(4, 1, "HL  ", PReg -> HL, OldRegisters. HL);
  putRegs(5, 1, "IX  ", PReg -> IX, OldRegisters. IX);
  putRegs(6, 1, "IY  ", PReg -> IY, OldRegisters. IY);
  gotoxy(59, 7); cputs("");
  putRegs(1 | 0x100, 1, "AF' ", PReg -> AF1, OldRegisters. AF1);
  putRegs(2 | 0x100, 1, "BC' ", PReg -> BC1, OldRegisters. BC1);
  putRegs(3 | 0x100, 1, "DE' ", PReg -> DE1, OldRegisters. DE1);
  putRegs(4 | 0x100, 1, "HL' ", PReg -> HL1, OldRegisters. HL1);
  putRegs(5 | 0x100, 1, "SP  ", PReg -> SP, OldRegisters. SP);
  putRegs(6 | 0x100, 1, "PC  ", PReg -> PC, OldRegisters. PC);
  gotoxy(59, 8); cputs(" S  Z  H  P/V  N  C  ");
  gotoxy(59, 9); cputs(" ");
  PC = (PReg -> AF) >> 8;
  i = (OldRegisters. AF) >> 8;
  putFlag( PC & 0x80, i & 0x80 );
  putFlag( PC & 0x40, i & 0x40 );
  putFlag( PC & 0x10, i & 0x10 );
  cputs(" "); putFlag( PC & 0x4, i & 4 ); cputs(" ");
  putFlag( PC & 2, i & 2 );
  putFlag( PC & 1, i & 1 );
  gotoxy(59, 10); cputs("");
  PC = PReg -> SP + 14;
  for (i = 24; i > 10; i--)
    {
      gotoxy(59, i);
      if (PReg -> SP == PC) cputs("");
	else cputs(" ");
      cprintf("%04X: %04X", PC, (PRAM[PC+1] << 8) | PRAM[PC]);
      PC -= 2;
      clreol();
    }
  PC = 0;
  for (i = 0; i < 8; i++)
    {
      gotoxy(73, i+17);
      while ( (PC < maxBkp) && !BkpUsed[PC] ) PC++;
      if ( PC >= maxBkp ) break;
      cprintf("#%1u %04X", i, Breakpoints[PC]);
      PC++;
    }
  enableCursor();
}

void DumpByte()
{
  int i;

  for (i = 0; i <= 23; i++)
    {
      getdbyte(DBYTE + i * 8);
      cputs(StrInstr); clreol();
      cputs("\x0d\x0a");
    }
}

void DumpWord()
{
  int i;

  for (i = 0; i <= 23; i++)
    {
      getdword(DWORD + i * 8);
      cputs(StrInstr); clreol();
      cputs("\x0d\x0a");
    }
}

void Show()
{
  textattr(0x1e);
  gotoxy(1, 1);
  switch (SMode) {
    case 1: { ShowCPU(); break; }
    case 2: { DumpByte(); break; }
    case 3: { DumpWord(); break; }
  }
  gotoxy(13 + Cur, 25);
}

void DecodeString(char s[])
{
  int i;

  i = Cur;
  while (CL[Cur] != 0 && CL[Cur] != ',')
    {
      s[Cur-i] = CL[Cur];
      Cur++;
    }
  s[Cur-i] = 0;
}

int DecodeInteger()
{
  char s[10];

  DecodeString(s);
  return atoi(s);
}

unsigned int getchars()
{
  char c1;
  unsigned x;

  if ( pending != 0 )
    {
      x = pending; pending = 0;
      return x;
    }
  c1 = getch();
  if (c1 == 0)
    return getch() << 8;
   else
    return c1;
}

void StatusLine(char s[])
{
  textattr(0x4f);
  gotoxy(1, 25);
  cputs(s); clreol();
}

void ShowCL()
{
  if ( !_Assembler ) StatusLine("DisasReady: ");
    else StatusLine("AssReady  : ");
  cputs(CL); clreol();
  gotoxy(13 + Cur, 25);
}

unsigned WaitStatusLine(char s[])
{
  StatusLine(s);
  Beep();
  return getchars();
}

void ReadROM()
{
  int Handle;
  char str[78];

  strcpy( str, emulDirectory );
  strcat( str, "rom.sha" );
  Handle = open( str, O_RDONLY | O_BINARY);
  if (Handle != -1)
    {
      lseek(Handle, 0x80, SEEK_CUR);
      if (read(Handle, (void far *)PROM, 0x4000) != 0x4000)
	WaitStatusLine("Error reading Sharp MZ-800 ROM. ");
      close(Handle);
    }
   else
    WaitStatusLine("Not found Sharp MZ-800 ROM. ");
}

void InsertChar(char c)
{
  int i;

  i = 0;
  while (CL[i++] != 0) {};
  i--;
  while (i >= Cur)
    {
      CL[i+1] = CL[i];
      i--;
    };
  CL[Cur++] = c;
}

void BackChar()
{
  int i;

  i = Cur;
  while (CL[i-1] != 0)
    {
      CL[i-1] = CL[i];
      i++;
    };
  CL[i-2] = 0;
  Cur--;
}

void DeleteChar()
{
  int i;

  i = Cur;
  while (CL[i] != 0)
    {
      CL[i] = CL[i+1];
      i++;
    };
  CL[i-1] = 0;
  ShowCL();
}

void DecodeBytes()
{
  Cur = 2;
  int PrevCur = 0;
  int Addr;
  switch ( SMode ) {
    case 1: Addr = CPUofs; break;
    case 2: Addr = DBYTE; break;
    case 3: Addr = DWORD; break;
  }
  while ( Cur != PrevCur )
    {
      PrevCur = Cur;
      unsigned X = DecodeAdress();
      if ( Cur != PrevCur ) PRAM[ Addr ++ ] = X;
      if ( CL[Cur] == 0 ) break;
      PrevCur++; Cur++;
    }
}

void DecodeAscii()
{
  int Addr;
  switch ( SMode ) {
    case 1: Addr = CPUofs; break;
    case 2: Addr = DBYTE; break;
    case 3: Addr = DWORD; break;
  }
  Cur = 2;
  while ( CL[Cur] != 0 )
    {
      PRAM[ Addr ++ ] = CL[Cur++];
    }
  PRAM[ Addr ] = 0;
}

void DecodeSharp()
{
  int Addr;
  switch ( SMode ) {
    case 1: Addr = CPUofs; break;
    case 2: Addr = DBYTE; break;
    case 3: Addr = DWORD; break;
  }
  Cur = 2;
  while ( CL[Cur] != 0 )
    {
      PRAM[ Addr++ ] = ASCIISX(CL[Cur++]);
    }
  PRAM[ Addr ] = 0;
}

void Move()
{
  Cur = 2;
  unsigned From = DecodeAdress(); Cur++;
  if ( CL[Cur] == 0 ) { ErrPrm(); return; }
  unsigned Where = DecodeAdress(); Cur++;
  if ( CL[Cur] == 0 ) { ErrPrm(); return; }
  unsigned Size = DecodeAdress();
  movmem( &PRAM[ From ], &PRAM[ Where ], Size );
}

void Enter()
{
  int Comm = 0;
  Cur = 0;
  if ( CL[0] >= '0' && CL[0] <= '9' )
    {
      AdrWrite(DecodeAdress());
      CL[0] = Cur = 0;
      return;
    }
  if ( ((tolower(CL[0]) == 'd') && (CL[1] >= '0' && CL[1] <= '9') ) )
    {
      AdrWrite(DecodeAdress());
      CL[0] = Cur = 0;
      return;
    }
  CL[0] = tolower( CL[0] );
  switch (*(int*)&CL[0]) {
    case 'a=': DecodeAscii(); Comm = 1; break;
    case 's=': DecodeSharp(); Comm = 1; break;
    case 'b=': DecodeBytes(); Comm = 1; break;
  }
  for ( int i = 0; CL[i] != 0; i++ )
    CL[i] = tolower( CL[i] );
  if ( (SMode == 1) && (CL[0] != '/') && (Comm == 0) )
    {
      Cur = Assembler( CL, CPUofs );
      if ( Cur > 0 )
	{
	  AdrWrite(CPUofs + Cur);
	  CL[0] = Cur = 0;
	  Show();
	  return;
	}
    }
  if ( (CL[0] == '/') && ( Comm == 0 ) )
    {
      Comm = 1;
      switch (CL[1]) {
	case 'c': textattr(0x1e); clrscr(); SMode = 1; printReg = 0; break;
	case 'd': SMode = 2; break;
	case 'w': SMode = 3; break;
	case 'k': _ASCII = !_ASCII; break;
	case 's': saveMemory(); printReg = 0; break;
	case 'l': loadMemory(); printReg = 0; break;
	case 'm': Move(); break;
	case 'f': unsigned XX = FindBytes();
		  if ( XX != 0xffff ) AdrWrite( XX );
		  break;
	case '/': XX = NextBytes();
		  if ( XX != 0xffff ) AdrWrite( XX );
		  break;
	case 'v': Cur += 2;
		  WaitStatusLine( ZXSharpVRAM(DecodeAdress()) );
		  break;
	case 'q': SpectrumLoad(); break;
	case 'o': DosLoad(); break;
	case 'h': SetMemory(); break;
	case '=': Calc(); break;
	case 'r': RamDisk(); break;
	default: Comm = 0;
     }
  }
  if ( Comm == 0 ) WaitStatusLine("Invalid command or instruction !!! ");
  CL[0] = Cur = 0;
}

void showExitStatus( unsigned ext )
{
  char *s;
  char s1[80];
  switch ( ext ) {
    case 1: s = "Invalid code of instruction"; break;
    case 2: s = "Breakpoint"; break;
    case 3: s = "Invalid command word 8253"; break;
    case 4: s = "8253 read error"; break;
    case 5: s = "8253 command word read error"; break;
    case 6: s = "User break"; break;
    case 7: s = "Invalid memory mapping"; break;
    case 8: s = "Invalid FDD controler command"; break;
    case 9: s = "Invalid video mode"; break;
    case 10: s = "Invalid setup of Z80-PIO"; break;
  }
  gotoxy(1,25); textattr(0x4f);
  strcpy(s1, "EMULATOR STATUS: ");
  strcat(s1, s); strcat(s1, " ... ");
  pending = WaitStatusLine( s1 );
}

void Ready()
{
  unsigned int c = kbF9;
  pending = 0;
  _ASCII = 0xff;	// sharp ascii
  textattr(0x1e);
  setmem( &CL, 80, 0 );
  do {
    int Era = 0;
    if ( c == 0 ) c = getchars();
    switch (c) {
      case kbPgDn: { AdrWriteX(_NextPC1(23)); Show(); break; }
      case kbPgUp: { AdrWriteX(PrevPC1(23)); Show(); break; }
      case kbDown: { AdrWrite(_NextPC1(1)); Show(); break; }
      case kbUp:   { AdrWrite(PrevPC1(1)); Show(); break; }
      case kbLeft: { if (Cur > 0) Cur--; ShowCL(); break; }
      case kbRight: { if (CL[Cur] != 0) Cur++; ShowCL(); break; }
      case kbDel:  { if (CL[Cur] != 0) DeleteChar(); ShowCL(); break; }
      case kbF1:
	{
	  showSInfo();
	  printReg = 0; Show(); Era = 1; break;
	}
      case kbF2:
	{
	  if ( SMode != 1 ) break;
	  int ppp = 0;
	  while ( ppp < maxBkp )
	    {
	      if ( BkpUsed[ppp] && (Breakpoints[ppp] == CPUofs) ) break;
	      ppp++;
	    }
	  if ( ppp < maxBkp )
	    {
	      BkpUsed[ppp] = 0;
	      printReg = 0; Show();
	      break;
	    }
	  ppp = 0;
	  while ( BkpUsed[ppp] && (ppp < maxBkp) ) ppp++;
	  if (ppp < maxBkp)
	    {
	      Breakpoints[ppp] = CPUofs;
	      BkpUsed[ppp] = 1;
	      BkpMap[ppp] = PSTSMEM -> MEMSTS;
	      printReg = 0; Show();
	    }
	   else
	    WaitStatusLine("No free breakpoints ... ");
	  c = 0;
	  break;
	}
     case kbF3:
	{
	  _AL = 0;		// all RAM
	  switchRAM();
	  WaitStatusLine( "All RAMs are active now. " );
	  c = 0; printReg = 0; Show(); ShowCL();
	  break;
	}
     case kbF4:
	{
	  if ( SMode != 1 ) break;
	  movmem( PReg, &OldRegisters, sizeof(OldRegisters) );
	  _AX = CPUofs;
	  unsigned ext = gotoCursor();
	  AdrWrite( PReg -> PC );
	  printReg = 0; Show();
	  if ( ext != 0 ) showExitStatus( ext );
	  Era = 1;
	  break;
	}
      case kbF5:
	{
	  showScreen(); getchars();
	  asm { mov ax, 3; int 10h }
	  printReg = 0; Show(); Era = 1; break;
	}
      case kbF6:
	{
	  showScrZX(); getchars();
	  asm { mov ax, 3; int 10h }
	  printReg = 0; Show(); Era = 1; break;
	}
      case kbF7:
	{
	  if ( SMode != 1 ) break;
	  movmem( PReg, &OldRegisters, sizeof(OldRegisters) );
	  unsigned ext = trap();
	  AdrWrite( PReg -> PC );
	  printReg = 0; Show();
	  if ( ext != 0 ) showExitStatus( ext );
	  Era = 1;
	  break;
	}
      case kbF8:
	{
	  if ( SMode != 1 ) break;
	  movmem( PReg, &OldRegisters, sizeof(OldRegisters) );
	  unsigned ext = trace();
	  AdrWrite( PReg -> PC );
	  printReg = 0; Show();
	  if ( ext != 0 ) showExitStatus( ext );
	  Era = 1;
	  break;
	}
      case kbF9:
	{
	  if ( SMode != 1 ) break;
	  movmem( PReg, &OldRegisters, sizeof(OldRegisters) );
	  char XX = PRAM[ PReg -> PC ];
	  breakpointsSet();
	  if ( PRAM[ PReg -> PC ] == 0x6d )
	    {
	      PRAM[ PReg -> PC ] = XX;
	      _AL = 0xff;
	    }
	   else
	    _AL = 0;
	  unsigned ext = emu_run();
	  breakpointsRes();
	  AdrWrite( PReg -> PC );
	  printReg = 0; Show();
	  if ( ext != 0 ) showExitStatus( ext );
	  Era = 1;
	  break;
	}
      case kbF10:
	{
	  if ( SMode != 1 ) break;
	  PReg -> PC = CPUofs; printReg = 0; Show();
	  c = 0;
	  break;
	}
      case kbAltF3:
	{
	  _AL = 1;		// all ROM
	  switchRAM();
	  WaitStatusLine( "All ROMs are active now. " );
	  c = 0; printReg = 0; Show();
	  ShowCL();
	  break;
	}
    }
    if ( Era )
      {
	c = 0; Cur = 0; setmem( &CL, 80, 0 ); ShowCL();
      }
    if ((c >= ' ' && c < 0x80) && Cur <= 60) {  InsertChar(c); ShowCL(); }
     else
    if (c == 8 && Cur > 0) { BackChar(); ShowCL(); }
    if (c == 13 && Cur > 0)
      {
	Enter();
	setmem( &CL, 80, 0 );
	Show(); ShowCL();
      };
    if ( (c == 0x1b) && _Assembler )
      { _Assembler = 0; c = 0; ShowCL(); }
    if ( c != 0x1b ) c = 0;
      else
       {
	 if ( tolower( WaitStatusLine( "Leave emulator (Y/ ) ? " ) ) == 'y' )
	   c = 0x1b;
	  else
	   c = 0;
	 ShowCL();
       }
  } while (c != 0x1b);
}

extern char cfgRD;

void createRD()
{
  char str[128];
  if ( !cfgRD ) {  RDHandle = -1; return; }
  strcpy( str, emulDirectory );
  strcat( str, "rd.sha" );
  if ( ( RDHandle = open( str, O_RDWR | O_BINARY ) ) != -1 ) return;
  if ( ( RDHandle = creatnew( str, 0 ) ) != - 1 )
    {
      close( RDHandle );
      if ( ( RDHandle = open( str, O_RDWR | O_BINARY ) ) != -1 )
	{
	  memset( &str, 0xe5, 128 );
	  for ( int i = 0; i < 4096; i++ )
	    if ( write( RDHandle, &str, 128 ) != 128 ) break;
	  if ( i < 4096 )
	    {
	      close( RDHandle );
	      WaitStatusLine("Disk full !!! I can't create RAM-disc. ");
	    }
	}
    }
}

void disassembler( unsigned int adr )
{
  createRD();
  PReg = (TRegisters *)getSPointer();
  PSTSMEM = (TSTSMEM *)getPtrMSTS();
  ACPU = DBYTE = DWORD = adr;
  setmem( PRAM, 0xffff, 0 );
  setmem( PROM, 0xffff, 0 );
  ReadROM();
  allInit( RAM, ROM, RDHandle );
  setmem( &OldRegisters, sizeof(OldRegisters), 0 );
  setmem( &BkpUsed, sizeof(BkpUsed), 0 );
  Ready();
  if ( RDHandle != -1 ) close( RDHandle );
}