; ==================================
;
;           Z80 - PIO
;
; ==================================

		EVEN
lpt_num		dw	0
		EVEN
INTR_ADR	db	0
		public	INTR_ADR
		EVEN
PIO_NEXT	db	0
		EVEN
intr_go		db	0
		public	intr_go
		EVEN
intr_imx	db	1
		public	intr_imx
		EVEN
intr_off	db	0ffh
		public	intr_off
		EVEN
intr_in		db	0
		public	intr_in
		EVEN
intr_enbl	db	0ffh
		public	intr_enbl
		EVEN
intr_poz	db	0
		public	intr_poz

out_pioA	proc	near

		pop	bx
		push	bx
		cmp	cs:PIO_NEXT, 0
		jz	@@0
		cmp	cs:PIO_NEXT, 1
		mov	cs:PIO_NEXT, 0
		jnz     @@01
		cmp	bh, 3fh
		jz	@@02
		mov	bx, 10
		jmp	error
@@02:		pop	bx
		ret
@@01:		test	bl, 10h
		jnz	@@03			; go on ...
		test	bl, 20h
		jnz	@@03
		pop	bx
		ret
@@03:		mov	cs:intr_go, 0ffh
		pop	bx
		ret
@@0:		mov	bl, bh
		and	bl, 0fh
		test	bl, 1		; nizsi polovina adresy obsluzneho prg
		jz	@@1
		cmp	bl, 0fh		; nastaveni
		jz	@@2
		cmp	bl, 7		; volba zdroje preruseni
		jz	@@3
		cmp	bl, 3		; povoleni/zakaz preruseni
		jz	@@4
		mov	bx, 10
		jmp	error
@@1:		mov	cs:INTR_ADR, bh
		pop	bx
		ret
@@2:	       	mov	bl, bh
		and	bl, 0c0h
		cmp	bl, 0c0h
		jz	@@21
		mov	bx, 10
		jmp	error
@@21:	       	mov	cs:PIO_NEXT, 1
		mov	cs:intr_go, 0
		pop	bx
		ret
@@3:		mov	cs:intr_off, 0ffh
		test	bh, 10000000b
		jz	@@31
		mov	cs:intr_off, 0
@@31:		test	bh, 00010000b
		jz	@@32
		mov	cs:PIO_NEXT, 2
@@32:		pop	bx
		ret
@@4:		mov	cs:intr_off, 0ffh
		test	bh, 10000000b
		jz	@@41
		mov	cs:intr_off, 0
@@41:		pop	bx
		ret

out_pioA	endp

		EVEN

out_pioB	proc	near

		pop	bx
		ret

out_pioB	endp

		EVEN

intr_rut	proc	near

		mov	cs:intr_in, 0ffh
		push	ds
		push	es
		push	ax
		push	si
		push	di
		push	cx
		cld
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	cx, 256
		mov	si, offset bas_instr
		mov	di, offset one_byte
		rep	movsw
		pop	cx
		pop	di
		pop	si
		pop	ax
		pop	es
		pop	ds
		mov	cs:intr_in, 0
		cmp	cs:intr_enbl, 0ffh		; povoleno EI ?
		jnz	@@1
		mov	cs:intr_in, 0ffh
		mov	cs:intr_poz, 0			; nuluj pozadavek
		cmp	cs:intr_imx, 1
		jz	@@01
		cmp	cs:intr_imx, 2
		jnz	@@1
		mov	cs:intr_enbl, 0
		mov	bl, cs:INTR_ADR
		mov	bh, cs:reg_i
		mov	bp, bx
		call	rword
		sub	di, 2
		mov	[di], si
		mov	si, bx
@@1:		mov	bh, 0
		mov	bl, [si]
@@11:		shl	bx, 1
		jmp	word ptr cs:[bx + offset one_byte]
@@01:		mov	cs:intr_enbl, 0
		dec	si
		mov	bx, 0ffh
		jmp	@@11

intr_rut	endp

; =======================================

		EVEN

_out_fe		db	0
_out_ff 	db	0
lpt_busy	db	2

		EVEN

out_fe		proc	near

		pop	bx
		cmp	cs:lpt_num, 0ffffh	; OFF ?
		jz	@@1
		and	bh, 11000000b
		test	bh, 01000000b		; inicializace LPT: ?
		jz	@@01
		push	dx
		push	ax
		mov	dx, cs:lpt_num
		mov	ah, 1
		int	17h
		pop	ax
		pop	dx
@@01:		test	cs:_out_fe, 10000000b
		mov	cs:_out_fe, bh
		jnz	@@1			; uz bylo nastaveno ?
		test	bh, 10000000b
		jz	@@02			; tiskni
		push	dx
		push	ax
		mov	dx, cs:lpt_num
		mov	al, cs:_out_ff
		mov	ah, 0
		int	17h
		pop	ax
		pop	dx
		mov	cs:lpt_busy, 2
@@02:
@@1:		ret

out_fe		endp

		EVEN

inp_fe		proc	near

		push	ax
		push	dx
		mov	bl, cs:_out_fe
		mov	bh, cs:frekv_33
		and	bh, 00110000b
		or	bl, bh
		cmp	cs:lpt_busy, 0
		jz	@@1
		dec	cs:lpt_busy
		mov	al, 1				; BUSY
		jmp	@@k
@@1:		mov	ah, 2
		mov	dx, cs:lpt_num
		int	17h
		mov	al, 2				; ERROR
		test	ah, 10h				; off line ?
		jz	@@k
		mov	bh, ah
		and	ah, 00101001b
		jnz	@@k				; ERROR
		mov	al, bh
		rol	al, 1
		not	al
		and	al, 1
@@k:		or	bl, al
		pop	dx
		pop	ax
		ret

inp_fe		endp

		EVEN

out_ff		proc	near

		pop	bx
		mov	cs:_out_ff, bh
		ret

out_ff		endp

		EVEN

inp_ff		proc	near

		mov	bl, cs:_out_ff
		ret

inp_ff		endp

; =======================================

initPIO		proc	near

		mov	cs:PIO_NEXT, 0
		mov	cs:intr_go, 0
		mov	cs:intr_imx, 0
		mov	cs:intr_off, 0ffh
		mov	cs:intr_in, 0
		mov	cs:intr_enbl, 0		; nepovol
		mov	cs:intr_poz, 0
		ret

initPIO		endp

_getLowIntrAdr	proc
		public	_getLowIntrAdr

		mov	al, cs:INTR_ADR
		mov	bl, cs:intr_enbl
		ret

_getLowIntrAdr	endp
