/*

	Nahravani z CMT:

*/

extern "C" {
int ASCIIS( int );
}

extern int getchars();
extern char far *PRAM;

#include <ctype.h>
#include <dos.h>
#include <dir.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <alloc.h>

#define kbUp 		0x4800
#define kbDown          0x5000
#define kbLeft		0x4b00
#define kbRight		0x4d00
#define kbPgUp		0x4900
#define kbPgDn		0x5100
#define kbHome		0x4700
#define kbEnd		0x4f00
#define kbDel		0x5300
#define kbF1		0x3b00
#define kbF2		0x3c00
#define kbF5		0x3f00
#define kbF7		0x4100
#define kbF8		0x4200
#define kbF9		0x4300
#define kbF10		0x4400

struct
{
  unsigned char PT;
  char name[17];
  unsigned int size;
  unsigned int begin;
  unsigned int start;
  char comment[104];
} head;


char directory[78];			// aktivni podadresar

char files[96][17];			// soubory, maximalne 96
int cntFiles;				// pocet souboru (vcetne podadresaru)
int cntDir;				// pocet podadresaru

int ofsShow;				// offset v show

char dosFile[15];

void showSharp( char *s, int size )
{
  for (int i = 0; i < size; i++ )
    putch( ASCIIS( s[i] ) );
}

void writeFileString( char s[] )
{
  strcpy( files[cntFiles++], s );
}

void readDirectories()			// nacte vsechny podadresare
{					// z aktivniho podadresare
  ffblk FF;
  char s[17];
  char str[78];

  cntFiles = cntDir = 0;
  strcpy( str, directory );
  strcat( str, "\\*.*" );
  if ( findfirst( str, &FF, 0x37 ) == 0 )		// poprve '.'
    while ( findnext( &FF ) == 0 )
      {
	if ( (FF. ff_attrib & 0x10) != 0 )
	  {
	     if ( s != NULL )
	       {
		 int i;
		 s[0] = '>'; s[1] = ' ';
		 for (i = 0; FF. ff_name[i] != 0; i++)
		   s[i + 2] = toupper(FF. ff_name[i]);
		 i += 2;
		 for (; i < 15; i++) s[i] = ' ';
		 s[15] = '<';
		 s[16] = 0;
		 writeFileString(s);
	       }
	  }
      }
  if ( (cntFiles == 0) && (strlen(directory) > 2) )
    {
      strcpy( s, "> ..           <" );
      writeFileString( s );
    }
  cntDir = cntFiles;
}

void readHeadOfFile( char *file )	// vstup MZF soubor
{
  char str[78];
  char s[17];
  int Handle;

  strcpy( str, directory );
  strcat( str, "\\" );
  strcat( str, file );
  if ( (Handle = open( str, O_RDONLY | O_BINARY )) != -1 )
    {
      read( Handle, &str, 18 );
      close( Handle );
      if ( s != NULL )
	{
	  int i;
	  for (i = 0; str[i+1] != 0x0d; i++) s[i] = ASCIIS( str[i+1] );
	  for (; i < 16; i++) s[i] = ' ';
	  s[16] = 0;
	  writeFileString( s );
	}
    }
}

void readFiles()			// nacte jmena souboru z hlavicek
{					// MZF souboru
  char str[78];
  ffblk FF;

  strcpy( str, directory );
  strcat( str, "\\*.mzf" );
  if ( findfirst( str, &FF, FA_ARCH | FA_RDONLY ) == 0 )
    {
      readHeadOfFile( FF. ff_name );
      while ( findnext( &FF ) == 0 )
	{
	  readHeadOfFile( FF. ff_name );
	}
    }
}

void decodeFilename()
{
  char str[78];
  ffblk FF;

  int count = ofsShow - cntDir;
  strcpy( str, directory );
  strcat( str, "\\*.mzf" );
  findfirst( str, &FF, FA_ARCH | FA_RDONLY );
  while ( count-- > 0 )
    {
      findnext( &FF );
    }
  strcpy( dosFile, FF. ff_name );
}

void showFiles()
{
  textattr( 0x1e );
  clrscr();
  if ( cntFiles == 0 )
    {
      gotoxy( 5, 10 ); cputs( " No files and directories found or error !!! " );
    }
  int i;
  int pom;
  for ( i = 0; i < 24; i++ )
    {
      gotoxy( 1, i + 1 );
      pom = i;
      if ( pom < cntFiles )
	{
	  cputs( "  " ); cputs( files[ pom ] ); cputs( "  " );
	  pom = i + 24;
	  if ( pom < cntFiles )
	    {
	      cputs( "  " ); cputs( files[ pom ] ); cputs( "  " );
	      pom = i + 24 + 24;
	      if ( pom < cntFiles )
		{
		  cputs( "  " ); cputs( files[ pom ] ); cputs( "  " );
		  pom = i + 24 + 24 + 24;
		  if ( pom < cntFiles )
		    {
		      cputs( files[ pom ] );
		    }
		}
	    }
	}
    }
  gotoxy(1, 25);
  textattr( 0x70 );
  cprintf(" Files : %3u   ", cntFiles - cntDir );
  textattr( 0x74 ); cputs("F1");
  textattr( 0x70 ); cputs(" File info  ");
  textattr( 0x74 ); cputs("F2");
  textattr( 0x70 ); cputs(" Drive  ");
  clreol(); gotoxy(80, 25);
}

void readAll()
{
  cntFiles = cntDir = 0;
  readDirectories();
  readFiles();
}

extern int ofsInv;
extern int lineWidth;
extern "C" void InvRadek( int );

void inverze()
{
  ofsInv = ((ofsShow / 24) * 40) + 4;
  lineWidth = 16;
  InvRadek( ofsShow % 24 + 1);
  ofsInv = 0;
}

void selectDrive()
{
  window(10, 10, 70, 15);
  textattr( 0x70 ); clrscr();
  gotoxy(3, 2);
  int c;
  int save = getdisk();
  int cnt = setdisk( save );
  c = 0;
  int end;
  cputs("Available logical drives    ");
  textattr( 0x74 );
  for (; cnt > 0; cnt--)
    {
      end = 0;
      while ( (c < 33) && (end == 0) )
	{
	  setdisk(c);
	  if ( getdisk() == c )
	    {
	      putch( c + 'A' ); cputs(":  ");
	      end = 1;
	    }
	  c++;
	}
    }
  window(10, 13, 70, 15);
  end = 0; gotoxy(1, 4);
  textattr( 0x78 );
  do {
    cputs("   Enter new drive : ");
    cprintf("\0x0d\0x0a");
    if ( (c = getch()) == 0 ) getch();
    if ( c == 0x1b ) end = 1;
    c = toupper(c);
    if ( (c < 'A') || (c > 'Z') ) c = 0;
    if ( c != 0 )
      {
	c -= 'A';
	setdisk( c );
	end = getdisk() == c;
	if ( end )
	  {
	     directory[0] = c + 'A';
	     directory[2] = 0;
	     readAll();
	  }
      }
  } while ( end == 0 );
  setdisk( save );
  window(1,1,80,25);
}

void loadNewDirectory()
{
  char str[78];
  char current[78];

  int i = strlen(directory);
  int j = 0;
  if ( *(int*)&files[ ofsShow ] [2] == '..' )
    {
      while ( directory[i] != '\\' ) i--;
      directory[i] = 0;
    }
   else
    {
      directory[i++] = '\\';
      int c;
      while ( ( c = files[ ofsShow ] [ j++ + 2 ] ) != ' ' )
	directory[i++] = c;
      directory[i] = 0;
    }
  readAll();
}

void showInfo()
{
  char str[78];
  int Handle;

  strcpy( str, directory );
  strcat( str, "\\" );
  strcat( str, dosFile );
  if ( ( Handle = open( str, O_RDONLY | O_BINARY ) ) != -1 )
    {
      read( Handle, &head, 0x80 );
      close( Handle );
      window( 15, 6, 65, 20 );
      textattr( 7 );
      clrscr();
      gotoxy(1, 3);
      cputs("   Filename :    ");
      int i;
      for ( i = 0 ; head. name[i] != 0x0d; i++) {};
      showSharp( head. name, i );
      cprintf("\r\n   Size     :    %04X", head. size);
      cprintf("\r\n   Begin    :    %04X", head. begin);
      cprintf("\r\n   Start    :    %04X\r\n\n", head. start);
      cprintf("   Comment  :\r\n");
      window(30, 13, 30 + 25, 19);
      showSharp( head. comment, 104 );
      window(1,1,80,25);
      gotoxy(80,25);
      if ( getch() == 0 ) getch();
    }
  window(1,1,80,25);
}

int selectFile()
{
  if ( cntFiles == 0 ) readAll();
  showFiles();
  int c;
  int shw;
  inverze();
  do {
    c = getchars();
    inverze();
    shw = 0;
    switch ( c ) {
      case kbUp: if ( ofsShow > 0 ) ofsShow--;
		break;
      case kbDown: if ( (ofsShow < 96) && (ofsShow + 1 < cntFiles) ) ofsShow++;
		break;
      case kbLeft: if ( ofsShow - 24 < 0 )
		     ofsShow = 0;
		    else
		     ofsShow -= 24;
		break;
      case kbRight: if ( ofsShow + 24 >= 96 )
		      {
			ofsShow = 95;
		      }
		     else
		      {
			ofsShow += 24;
			if ( ofsShow >= cntFiles ) ofsShow = cntFiles - 1;
		      }
		break;
      case kbF1: decodeFilename(); showInfo(); shw = 1; break;
      case kbF2: selectDrive(); ofsShow = 0; shw = 1; break;
      case 0x0d: if ( ofsShow < cntDir )
		   {
		     loadNewDirectory();
		     ofsShow = c = 0; shw = 1;
		   }
		  else
		   decodeFilename();
		break;
    }
    if ( shw ) showFiles();
    inverze();
  } while ( (c != 0x1b) && (c != 0x0d) );
  return c == 0x1b;
}

int far _loadds _loadHead( unsigned kam )
{
  int Handle;
  char str[78];

  strcpy( str, directory );
  strcat( str, "\\" );
  strcat( str, dosFile );

  if ( ( Handle = open( str, O_RDONLY | O_BINARY ) ) != -1 )
    {
      read( Handle, &PRAM[kam], 0x80 );
      close( Handle );
      return 0;
    }
   else return 1;
}

int far _loadds _loadProgram( unsigned kam, unsigned kolik )
{
  int Handle;
  char str[78];

  strcpy( str, directory );
  strcat( str, "\\" );
  strcat( str, dosFile );

  if ( ( Handle = open( str, O_RDONLY | O_BINARY ) ) != -1 )
    {
      lseek( Handle, 0x80, SEEK_SET );
      read( Handle, &PRAM[kam], kolik );
      close( Handle );
      return 0;
    }
   else return 1;
}

int far _loadds _loadSelHead( unsigned kam )
{
  asm { mov ax, 3; int 10h; }
  if ( selectFile() ) return 1;
  return _loadHead( kam );
}

extern "C" void setLoadPtrs( void far *, void far *, void far *, char far * );

void loadInit()
{
  char str [78];

  setLoadPtrs( _loadSelHead, _loadProgram, _loadHead, dosFile );

  directory[0] = getdisk() + 'A';
  directory[1] = ':';
  directory[2] = '\\';
  getcurdir( 0, &directory[3] );
  cntFiles = cntDir = ofsShow = 0;
}

